
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Analytics_dailyDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const analytics_daily = await db.analytics_daily.create(
            {
                id: data.id || undefined,
        
        metric_date: data.metric_date
        ||
        null
            ,
            
        streams: data.streams
        ||
        null
            ,
            
        unique_listeners: data.unique_listeners
        ||
        null
            ,
            
        saves: data.saves
        ||
        null
            ,
            
        likes: data.likes
        ||
        null
            ,
            
        shares: data.shares
        ||
        null
            ,
            
        country: data.country
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        traffic_source: data.traffic_source
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await analytics_daily.setArtist_profile( data.artist_profile || null, {
            transaction,
        });
        
        await analytics_daily.setPlatform( data.platform || null, {
            transaction,
        });
        
        await analytics_daily.setRelease( data.release || null, {
            transaction,
        });
        
        await analytics_daily.setTrack( data.track || null, {
            transaction,
        });
        
        await analytics_daily.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return analytics_daily;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const analytics_dailyData = data.map((item, index) => ({
                id: item.id || undefined,
                
                metric_date: item.metric_date
            ||
            null
            ,
            
                streams: item.streams
            ||
            null
            ,
            
                unique_listeners: item.unique_listeners
            ||
            null
            ,
            
                saves: item.saves
            ||
            null
            ,
            
                likes: item.likes
            ||
            null
            ,
            
                shares: item.shares
            ||
            null
            ,
            
                country: item.country
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                traffic_source: item.traffic_source
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const analytics_daily = await db.analytics_daily.bulkCreate(analytics_dailyData, { transaction });

        // For each item created, replace relation files
        

        return analytics_daily;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const analytics_daily = await db.analytics_daily.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.metric_date !== undefined) updatePayload.metric_date = data.metric_date;
        
        
        if (data.streams !== undefined) updatePayload.streams = data.streams;
        
        
        if (data.unique_listeners !== undefined) updatePayload.unique_listeners = data.unique_listeners;
        
        
        if (data.saves !== undefined) updatePayload.saves = data.saves;
        
        
        if (data.likes !== undefined) updatePayload.likes = data.likes;
        
        
        if (data.shares !== undefined) updatePayload.shares = data.shares;
        
        
        if (data.country !== undefined) updatePayload.country = data.country;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.traffic_source !== undefined) updatePayload.traffic_source = data.traffic_source;
        
        
        updatePayload.updatedById = currentUser.id;

        await analytics_daily.update(updatePayload, {transaction});

        
        
        if (data.artist_profile !== undefined) {
            await analytics_daily.setArtist_profile(
              
              data.artist_profile,
              
              { transaction }
            );
        }
        
        if (data.platform !== undefined) {
            await analytics_daily.setPlatform(
              
              data.platform,
              
              { transaction }
            );
        }
        
        if (data.release !== undefined) {
            await analytics_daily.setRelease(
              
              data.release,
              
              { transaction }
            );
        }
        
        if (data.track !== undefined) {
            await analytics_daily.setTrack(
              
              data.track,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await analytics_daily.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return analytics_daily;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const analytics_daily = await db.analytics_daily.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of analytics_daily) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of analytics_daily) {
                await record.destroy({transaction});
            }
        });


        return analytics_daily;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const analytics_daily = await db.analytics_daily.findByPk(id, options);

        await analytics_daily.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await analytics_daily.destroy({
            transaction
        });

        return analytics_daily;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const analytics_daily = await db.analytics_daily.findOne(
            { where },
            { transaction },
        );

        if (!analytics_daily) {
            return analytics_daily;
        }

        const output = analytics_daily.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.artist_profile = await analytics_daily.getArtist_profile({
            transaction
        });
        
        
        output.platform = await analytics_daily.getPlatform({
            transaction
        });
        
        
        output.release = await analytics_daily.getRelease({
            transaction
        });
        
        
        output.track = await analytics_daily.getTrack({
            transaction
        });
        
        
        output.organizations = await analytics_daily.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.artist_profiles,
        as: 'artist_profile',
        
        where: filter.artist_profile ? {
          [Op.or]: [
            { id: { [Op.in]: filter.artist_profile.split('|').map(term => Utils.uuid(term)) } },
            {
              artist_name: {
                [Op.or]: filter.artist_profile.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.distribution_platforms,
        as: 'platform',
        
        where: filter.platform ? {
          [Op.or]: [
            { id: { [Op.in]: filter.platform.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.platform.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.releases,
        as: 'release',
        
        where: filter.release ? {
          [Op.or]: [
            { id: { [Op.in]: filter.release.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.release.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tracks,
        as: 'track',
        
        where: filter.track ? {
          [Op.or]: [
            { id: { [Op.in]: filter.track.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.track.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'analytics_daily',
                        'country',
                        filter.country,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'analytics_daily',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.traffic_source) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'analytics_daily',
                        'traffic_source',
                        filter.traffic_source,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            metric_date: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    metric_date: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.metric_dateRange) {
                const [start, end] = filter.metric_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    metric_date: {
                    ...where.metric_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    metric_date: {
                    ...where.metric_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.streamsRange) {
                const [start, end] = filter.streamsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    streams: {
                    ...where.streams,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    streams: {
                    ...where.streams,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unique_listenersRange) {
                const [start, end] = filter.unique_listenersRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unique_listeners: {
                    ...where.unique_listeners,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unique_listeners: {
                    ...where.unique_listeners,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.savesRange) {
                const [start, end] = filter.savesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    saves: {
                    ...where.saves,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    saves: {
                    ...where.saves,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.likesRange) {
                const [start, end] = filter.likesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    likes: {
                    ...where.likes,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    likes: {
                    ...where.likes,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sharesRange) {
                const [start, end] = filter.sharesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    shares: {
                    ...where.shares,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    shares: {
                    ...where.shares,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.analytics_daily.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'analytics_daily',
                        'traffic_source',
                        query,
                    ),
                ],
            };
        }

        const records = await db.analytics_daily.findAll({
            attributes: [ 'id', 'traffic_source' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['traffic_source', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.traffic_source,
        }));
    }

    
};

